//
//  AttackReportTableViewController.m
//  kid_peak_flow
//
//  Created by mixalis menesidis on 13/5/13.
//  Copyright (c) 2013 mixalis menesidis. All rights reserved.
//

#import "AttackReportTableViewController.h"
#import "ECSlidingViewController.h"
#import "SlideMenuViewController.h"
#import "FormKit.h"
#import "Asthma.h"
#import "Comment.h"
#import "Genre.h"
#import "BWLongTextViewController.h"
#import "database.h"
#import "sqlite3.h"
#import "SimplePost.h"
#import "Task.h"

@interface AttackReportTableViewController ()

@end

@implementation AttackReportTableViewController

@synthesize slideMenuBtn;
@synthesize saveButton;
@synthesize formModel;
@synthesize asth_attack = _movie;

@synthesize db;

static NSString *kAddTask = @"http://192.168.1.107/my_tasks/add_task.php";


- (void)viewDidLoad
{
    // kalo ti synarthsh db
    //database *db = [[database alloc] init];
    //[db openDB];
 //   [db createTable:@"tableAttack" withField1:@"Date" withField2:@"Duration" withField3:@"PrePost" withField4:@"Notes" withField5:@"Location"];
   // [db createTable:@"summary" withField1:@"firstName" withField2:@"surName"];
 
    
    [super viewDidLoad];
    
    
    self.formModel = [FKFormModel formTableModelForTableView:self.tableView
                                        navigationController:self.navigationController];
    
    Asthma *movie = [Asthma movieWithTitle:@""
                                 content:@"Info about asthma attack"];
    

    
    // INITIALIZATION
    movie.duration = [NSNumber numberWithInt:0];
    
    
    self.asth_attack = movie;
    
    [FKFormMapping mappingForClass:[Asthma class] block:^(FKFormMapping *formMapping) {
        [formMapping sectionWithTitle:@"" footer:@"" identifier:@"info"];
        //[formMapping mapAttribute:@"title" title:@"Title" type:FKFormAttributeMappingTypeText];
        
        //        [formMapping mapAttribute:@"releaseDate" title:@"ReleaseDate" type:FKFormAttributeMappingTypeDate dateFormat:@"yyyy-MM-dd HH:mm:ss"];
        
        [formMapping mappingForAttribute:@"dateAttack"
                                   title:@"Date of Attack"
                                    type:FKFormAttributeMappingTypeDate
                        attributeMapping:^(FKFormAttributeMapping *mapping) {
                            
                            mapping.dateFormat = @"yyyy-MM-dd";
                        }];
        
        //[formMapping mapAttribute:@"suitAllAges" title:@"All ages" type:FKFormAttributeMappingTypeBoolean];
       // [formMapping mapAttribute:@"shortName" title:@"ShortName" type:FKFormAttributeMappingTypeLabel];
        [formMapping mapAttribute:@"duration" title:@"Duration (min)" type:FKFormAttributeMappingTypeInteger];
        
        [formMapping mapAttribute:@"prepostMeds"
                            title:@"Pre/Post Meds"
                     showInPicker:NO
                selectValuesBlock:^NSArray *(id value, id object, NSInteger *selectedValueIndex){
                    *selectedValueIndex = 1;
                    return [NSArray arrayWithObjects:@"Pre Medication", @"Post Medication", nil];
                    
                } valueFromSelectBlock:^id(id value, id object, NSInteger selectedValueIndex) {
                    return value;
                    
                } labelValueBlock:^id(id value, id object) {
                    return value;
                    
                }];
        
        [formMapping mapAttribute:@"notes" title:@"Notes" type:FKFormAttributeMappingTypeBigText];
        
        //        Doesn't work very good now
        //[formMapping mapSliderAttribute:@"rate" title:@"Rate" minValue:0 maxValue:10 valueBlock:^NSString *(id value) {
          //  return [NSString stringWithFormat:@"%.1f", [value floatValue]];
       // }];
        
        [formMapping mapAttribute:@"location"
                            title:@"Location"
                     showInPicker:NO
                selectValuesBlock:^NSArray *(id value, id object, NSInteger *selectedValueIndex){
                    *selectedValueIndex = 1;
                    return [NSArray arrayWithObjects:@"School", @"Home", @"Outside", nil];
                    
                } valueFromSelectBlock:^id(id value, id object, NSInteger selectedValueIndex) {
                    return value;
                    
                } labelValueBlock:^id(id value, id object) {
                    return value;
                    
                }];
        
     /*   [formMapping sectionWithTitle:@"Custom cells" identifier:@"customCells"];
        
        [formMapping mapCustomCell:[UITableViewCell class]
                        identifier:@"custom"
                         rowHeight:70
              willDisplayCellBlock:^(UITableViewCell *cell, id object, NSIndexPath *indexPath) {
                  cell.textLabel.text = @"I am a custom cell !";
                  
              }     didSelectBlock:^(UITableViewCell *cell, id object, NSIndexPath *indexPath) {
                  NSLog(@"You pressed me");
                  
              }];
        
        [formMapping mapCustomCell:[UITableViewCell class]
                        identifier:@"custom2"
              willDisplayCellBlock:^(UITableViewCell *cell, id object, NSIndexPath *indexPath) {
                  cell.textLabel.text = @"I am a custom cell too !";
                  
              }     didSelectBlock:^(UITableViewCell *cell, id object, NSIndexPath *indexPath) {
                  NSLog(@"You pressed me");
                  
              }];
        
        [formMapping sectionWithTitle:@"Buttons" identifier:@"saveButton"];
        
        [formMapping buttonSave:@"Save" handler:^{
            NSLog(@"save pressed");
            NSLog(@"%@", self.movie);
            [self.formModel save];
        }]; 
        
        [formMapping validationForAttribute:@"title" validBlock:^BOOL(NSString *value, id object) {
            return value.length < 10;
            
        } errorMessageBlock:^NSString *(id value, id object) {
            return @"Text is too long.";
        }]; */
        
        [formMapping validationForAttribute:@"releaseDate" validBlock:^BOOL(id value, id object) {
            return NO;
        }];
        
        [self.formModel registerMapping:formMapping];
    }];
    
    [self.formModel setDidChangeValueWithBlock:^(id object, id value, NSString *keyPath) {
        NSLog(@"did change model value");
    }];
    
    [self.formModel loadFieldsWithObject:movie];
    
    
    self.view.layer.shadowOpacity = 0.75f;
    self.view.layer.shadowRadius = 10.0f;
    self.view.layer.shadowColor = [UIColor blackColor].CGColor;
    
    
    if (![self.slidingViewController.underLeftViewController isKindOfClass:[SlideMenuViewController class]]) {
        self.slidingViewController.underLeftViewController  = [self.storyboard instantiateViewControllerWithIdentifier:@"SlideMenu"];
    }
    
    self.slideMenuBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    slideMenuBtn.frame = CGRectMake(8, 10, 34, 24);
    [slideMenuBtn setBackgroundImage:[UIImage imageNamed:@"Button.png"] forState:UIControlStateNormal];
    [slideMenuBtn addTarget:self action:@selector(revealMenu:) forControlEvents:UIControlEventTouchUpInside];
    
    
    [self.view addSubview:self.slideMenuBtn];
    
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
    
    
    [[self navigationController] setNavigationBarHidden:NO animated:NO];
    
    
  saveButton = [[UIBarButtonItem alloc]initWithTitle:@"Save" style:UIBarButtonItemStyleBordered target:self action:@selector(saveEntry:)];
    
    [self.navigationController.navigationBar.topItem setTitle:@"Attack Report"];
    
    [self.navigationController.navigationBar.topItem setRightBarButtonItem:saveButton];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
#warning Potentially incomplete method implementation.
    // Return the number of sections.
    return 0;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
#warning Incomplete method implementation.
    // Return the number of rows in the section.
    return 0;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    // Configure the cell...
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
}
- (void)viewDidUnload {
    [super viewDidUnload];
    
    self.formModel = nil;
    self.asth_attack = nil;
}
- (IBAction)revealMenu:(id)sender
{
    [self.slidingViewController anchorTopViewTo:ECRight];
}


-(IBAction)saveEntry:(id)sender{
    db = [[database alloc] init];

    
    [db updateAttack:self.asth_attack.dateAttack :self.asth_attack.duration :self.asth_attack.prepostMeds:self.asth_attack.notes :self.asth_attack.location];
    ///
//    Task *userID = [[Task alloc] initWithName:@"1"];
///    NSMutableURLRequest *request_userID = [SimplePost urlencodedRequestWithURL:[NSURLURLWithString:kAddTask] andDataDictionary:[userID toDictionary:@"userID"]];
//    [[NSURLConnection alloc] initWithRequest:request_userID delegate:self];
    
    
    NSDateFormatter *dateFormatter2 = [[NSDateFormatter alloc] init];
    [dateFormatter2 setDateFormat:@"yyyy-MM-dd"];
    NSString *dateAttackString = [dateFormatter2 stringFromDate:self.asth_attack.dateAttack];
    
    NSString *sduration = [NSString stringWithFormat:@"%@ %@min %@ %@ %@", dateAttackString, self.asth_attack.duration, self.asth_attack.prepostMeds, self.asth_attack.notes, self.asth_attack.location];
    Task *attacks = [[Task alloc] initWithName:sduration];
    NSMutableURLRequest *request_attacks = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[attacks toDictionary:@"attacks"]];
    [[NSURLConnection alloc] initWithRequest:request_attacks delegate:self];

    ///
    //NSNumber *duration = self.movie.duration;
    UIAlertView *message = [[UIAlertView alloc] initWithTitle:@"Attack Report"
                                                      message:@"Your attack report has been saved"
                                                     delegate:nil
                                            cancelButtonTitle:@"OK"
                                            otherButtonTitles:nil];
    [message show];
} 
@end