//
//  AppDelegate.m
//  FormKitDemo
//
//  Created by Bruno Wernimont on 8/07/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"
#import "DemoTableViewController.h"
#import "FormTableViewExampleController.h"
#import "InitViewController.h"
@implementation AppDelegate

@synthesize window = _window;


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{

    
    char *emsg;
    BOOL fileExist;
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    fileExist = [[NSFileManager alloc] fileExistsAtPath:documentPath];
    
    if(!fileExist){
        
        if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
        {
            NSLog(@"An error has occured.");
            
        }else{
            
            // CREATE ATTACK TABLE
            const char *sqlAttackTable = "create table if not exists attackTable(dateAttack, duration, prepostMeds, notes, location)";
            
            if(sqlite3_exec(db, sqlAttackTable, NULL, NULL, &emsg) != SQLITE_OK)
            {
                NSLog(@"There is a problem with statement");
                
            }
            // CREATE SYMPTOMS TABLE
            const char *sqlSymptomsTable = "create table if not exists symptomsTable(date, wheezing, dcough, sbreath, wchest, sleep)";
            
            if(sqlite3_exec(db, sqlSymptomsTable, NULL, NULL, &emsg) != SQLITE_OK)
            {
                NSLog(@"There is a problem with statement");
                
            }
            // CREATE TRIGGERS TABLE
            const char *sqlTriggersTable = "create table if not exists triggersTable(dateTriggers, dust, pollen, exercise, smoke, illness, food, allergy, highTemp, lowTemp)";
            
            if(sqlite3_exec(db, sqlTriggersTable, NULL, NULL, &emsg) != SQLITE_OK)
            {
                NSLog(@"There is a problem with statement");
                
            }
            // CREATE PEAKFLOW TABLE
            const char *sqlpeakflowTable = "create table if not exists peakflowTable(datePeakFlow, peakflow)";
            
            if(sqlite3_exec(db, sqlpeakflowTable, NULL, NULL, &emsg) != SQLITE_OK)
            {
                NSLog(@"There is a problem with statement");
                
            }
            // CREATE PERSONAL DETAILS
            const char *sqlpersonaldetailsTable = "create table if not exists personaldetailsTable(userID, name, surname, gender,dob, height, weight, doctorname, doctormail)";
            
            if(sqlite3_exec(db, sqlpersonaldetailsTable, NULL, NULL, &emsg) != SQLITE_OK)
            {
                NSLog(@"There is a problem with statement");
                
            }
            // CREATE MEDICATION
            const char *sqlmedicationTable = "create table if not exists medicationTable(medicationID, inputmedication, dose, inputmedication2, dose2, inputmedication3, dose3)";
            
            if(sqlite3_exec(db, sqlmedicationTable, NULL, NULL, &emsg) != SQLITE_OK)
            {
                NSLog(@"There is a problem with statement");
                
            }
        }
        
    }

    // Override point for customization after application launch.
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Saves changes in the application's managed object context before the application terminates.
}


@end
