//
//  database.m
//  kid_peak_flow
//
//  Created by mixalis menesidis on 16/5/13.
//  Copyright (c) 2013 mixalis menesidis. All rights reserved.
//

#import "database.h"

@implementation database

// FUNCTIONS ATTACK
-(void) updateAttack:(NSString *)date :(NSNumber *) duration :(NSNumber *)prepostMeds :(NSString *)notes: (NSNumber *)location{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    // DATE
   // NSDate *now = [NSDate date];
    //NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    //NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];

    //NSDate *today = [calendar dateFromComponents:components];

    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        NSString *insertSQL = [NSString stringWithFormat:
                               @"INSERT INTO attackTable(dateAttack, duration, prepostMeds, notes, location) VALUES ('%@','%@','%@','%@','%@')",
                               date ,duration,prepostMeds, notes, location] ;
        
        const char *sql = [insertSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"Problem with prepare statement");
            return;
        }else{
            
            if(sqlite3_step(sqlStatement)==SQLITE_DONE){
                sqlite3_finalize(sqlStatement);
                sqlite3_close(db);
            }
            
        }
    }
    
}
-(void) selectAttack{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        
        
        const char *sql = "select dateAttack, duration, prepostMeds, notes, location from attackTable";
        
        sqlite3_stmt *sqlStatement;
        
        
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"There is a problem with prepare statement");
            return;
        }else{
            while (sqlite3_step(sqlStatement)==SQLITE_ROW) {
                
                char * checkChar = (char*)sqlite3_column_text(sqlStatement, 1);
                if (checkChar!=NULL) {
                    Asthma * newToDo = [[Asthma alloc] init];
                   // newToDo.duration = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)];
                   // newToDo.prepost= [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)];
                    NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)]);
                    NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)]);
          
                }
                
            }
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }        
    
}

-(int) GetNumbersOfAttacks{
    int count =0;
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        NSDate *dateCompare = [NSDate date];
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy-MM"];
   
        
        NSString *CurrentDate = [dateFormatter stringFromDate:dateCompare];        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT COUNT (*) FROM attackTable WHERE dateAttack LIKE '%@%%' ",CurrentDate];
        
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                count = sqlite3_column_int(sqlStatement, 0);
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    return count;
}

- (int) GetDailyCountSymptoms
{
    int count = 0;

    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
        if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
        {
            NSLog(@"An error has occured.");
        }
        else
        {
            // DATE
            NSDate *now = [NSDate date];
            NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
            NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
            [components setHour:10];
            NSDate *today10am = [calendar dateFromComponents:components];
            NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
            [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss ZZZZ"];
            
            
            NSString *symptomsDate = [dateFormatter stringFromDate:today10am];
            
            
            NSString *selectSQL =[NSString stringWithFormat:
                                  @"SELECT COUNT (*) FROM symptomsTable WHERE date='%@'",symptomsDate];
            
            const char *sql = [selectSQL UTF8String];
            
            sqlite3_stmt *sqlStatement;
            if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
            {
                
                //Loop through all the returned rows (should be just one)
                while( sqlite3_step(sqlStatement) == SQLITE_ROW )
                {
                    count = sqlite3_column_int(sqlStatement, 0);
                }
            
            }
            else {
                NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );

            }
            
            if(sqlite3_step(sqlStatement)==SQLITE_DONE){
                sqlite3_finalize(sqlStatement);
                sqlite3_close(db);
            }

        }
   

    
    return count;
}

//////// FUNCTIONS SYMPTOMS ///////////////

-(void) updateSymptoms:(NSString *) date:(NSString *) wheezing :(NSString *)dcough :(NSString *)sbreath:(NSString *) wchest: (NSString *) sleep{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        
        int count = [self GetDailyCountSymptoms];
        NSLog(@"%d",count);
        NSString *insertSQL;
        
        // ELEGXOS GIA AN YPARXEI PRWTH EGGRAFH 
        if (count==0) {
            insertSQL = [NSString stringWithFormat:
                                   @"INSERT INTO symptomsTable (date, wheezing, dcough, sbreath, wchest, sleep) VALUES ('%@','%@','%@','%@','%@','%@')",
                                   date , wheezing, dcough, sbreath, wchest, sleep];

        }
        else // UPDATE TIS PRWTHS EGGRAFHS
        {
             insertSQL = [NSString stringWithFormat:@"UPDATE symptomsTable SET date='%@', wheezing='%@',dcough='%@',sbreath='%@', wchest='%@', sleep='%@' WHERE date='%@'", date , wheezing, dcough, sbreath, wchest, sleep, date];
        }
        
        
        const char *sql = [insertSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"Problem with prepare statement");
            return;
        }else{
            
            if(sqlite3_step(sqlStatement)==SQLITE_DONE){
                sqlite3_finalize(sqlStatement);
                sqlite3_close(db);
            }
            
        }
    }
    
}
-(void) selectSymptoms{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        
        
        const char *sql = "select date, wheezing, dcough, sbreath, wchest, sleep from symptomsTable";
        
        sqlite3_stmt *sqlStatement;
        
        
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"There is a problem with prepare statement");
            return;
        }else{
            while (sqlite3_step(sqlStatement)==SQLITE_ROW) {
                
                char * checkChar = (char*)sqlite3_column_text(sqlStatement, 1);
                if (checkChar!=NULL) {
                    Asthma * newToDo = [[Asthma alloc] init];
                    // newToDo.duration = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)];
                    // newToDo.prepost= [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)];
                    NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)]);
                    NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)]);
                    
                }
                
            }
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
}

//////// FUNCTIONS TRIGGERS ///////////////

-(void)updateTriggers:(NSString *)dateTriggers:(NSString *)dust :(NSString *)pollen :(NSString *)exercise :(NSString *)smoke :(NSString *)illness :(NSString *)food :(NSString *)allergy :(NSString *)highTemp :(NSString *)lowTemp{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        
        int count = [self GetDailyCountTriggers];
        NSLog(@"%d",count);
        NSString *insertSQL;
        
         // ELEGXOS GIA AN YPARXEI PRWTH EGGRAFH
        if (count==0) {
            insertSQL = [NSString stringWithFormat:
                         @"INSERT INTO triggersTable (dateTriggers, dust, pollen, exercise, smoke, illness, food, allergy, highTemp, lowTemp) VALUES ('%@','%@','%@','%@','%@','%@','%@','%@','%@','%@')",
                         dateTriggers, dust , pollen, exercise, smoke, illness, food, allergy, highTemp, lowTemp];
            
        }
        else // UPDATE TIS PRWTHS EGGRAFHS
        {
            insertSQL = [NSString stringWithFormat:@"UPDATE triggersTable SET dateTriggers ='%@',dust='%@', pollen='%@',exercise='%@',smoke='%@', illness='%@', food='%@', allergy='%@', highTemp='%@', lowTemp='%@' WHERE dateTriggers='%@'", dateTriggers , dust, pollen, exercise, smoke, illness, food, allergy, lowTemp, highTemp,dateTriggers];
        }
        
        
        const char *sql = [insertSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"Problem with prepare statement");
            return;
        }else{
            
            if(sqlite3_step(sqlStatement)==SQLITE_DONE){
                sqlite3_finalize(sqlStatement);
                sqlite3_close(db);
            }
            
        }
    }
    
}

-(void) selectTriggers{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        
        
        const char *sql = "select dateTriggers, dust, pollen, exercise, smoke, illness, food, lowTemp, highTemp from triggersTable";
        
        sqlite3_stmt *sqlStatement;
        
        
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"There is a problem with prepare statement");
            return;
        }else{
            while (sqlite3_step(sqlStatement)==SQLITE_ROW) {
                
                char * checkChar = (char*)sqlite3_column_text(sqlStatement, 1);
                if (checkChar!=NULL) {
                    Asthma * newToDo = [[Asthma alloc] init];
                    // newToDo.duration = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)];
                    // newToDo.prepost= [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)];
                    NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)]);
                    NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)]);
                    
                }
                
            }
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
}

- (int) GetDailyCountTriggers
{
    int count = 0;
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss ZZZZ"];
        
        
        NSString *triggerDate = [dateFormatter stringFromDate:today10am];
        
        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT COUNT (*) FROM triggersTable WHERE dateTriggers='%@'",triggerDate];
        
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                count = sqlite3_column_int(sqlStatement, 0);
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    
    
    return count;
}
//////// FUNCTIONS PEAKFLOW ///////////////

-(void)updatePeakFlow:(NSString *)datePeakFlow :(NSString *)peakflow{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        

        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss ZZZZ"];
        
        
        NSString *PeakFlowString = [dateFormatter stringFromDate:today10am];
        int count = [self GetDailyCountPeakFlow];
        NSLog(@"%d",count);
        NSString *insertSQL;
        NSLog(@"edwww:");
        NSLog(PeakFlowString);
        
        // ELEGXOS GIA AN YPARXEI PRWTH EGGRAFH
        if (count==0) {
            insertSQL = [NSString stringWithFormat:
                         @"INSERT INTO peakflowTable (datePeakFlow, peakflow) VALUES ('%@','%@')",
                         PeakFlowString,peakflow];
            
        }
        else // UPDATE TIS PRWTHS EGGRAFHS
        {
            
            insertSQL = [NSString stringWithFormat:@"UPDATE peakflowTable SET datePeakFlow ='%@',peakflow='%@' WHERE datePeakFlow='%@'", PeakFlowString, peakflow,PeakFlowString];
                         //NSNumber numberWithDouble:[ today10am timeIntervalSinceReferenceDate]]
        }
        
        
        const char *sql = [insertSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"Problem with prepare statement");
            return;
        }else{
            
            if(sqlite3_step(sqlStatement)==SQLITE_DONE){
                sqlite3_finalize(sqlStatement);
                sqlite3_close(db);
            }
            
        }
    }
    
}

-(void) selectPeakFlow{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        
        
        const char *sql = "select datePeakFlow, peakflow from peakflowTable";
        
        sqlite3_stmt *sqlStatement;
        
        
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"There is a problem with prepare statement");
            return;
        }else{
            while (sqlite3_step(sqlStatement)==SQLITE_ROW) {
                
                char * checkChar = (char*)sqlite3_column_text(sqlStatement, 1);
                if (checkChar!=NULL) {
                    Asthma * newToDo = [[Asthma alloc] init];
                    // newToDo.duration = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)];
                    // newToDo.prepost= [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)];
                    NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)]);
                    NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)]);
                    
                }
                
            }
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
}

- (int) GetDailyCountPeakFlow
{
    int count = 0;
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss ZZZZ"];
        
        
        NSString *PeakFlowString = [dateFormatter stringFromDate:today10am];
        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT COUNT (*) FROM peakflowTable WHERE datePeakFlow='%@'",PeakFlowString];
        
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                count = sqlite3_column_int(sqlStatement, 0);
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    
    
    return count;
}
//////// FUNCTIONS PERSONAL DETAILS///////////////

-(void)updatePersonalDetails:(NSString *)name :(NSString *)surname :(NSString *)gender :(NSString *)dob :(NSNumber *)height :(NSNumber *)weight :(NSString *)doctorname :(NSString *)doctormail{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        
        int count = [self GetDailyCountPersonalDetails];
        NSLog(@"%d",count);
        NSString *insertSQL;
        
        // ELEGXOS GIA AN YPARXEI PRWTH EGGRAFH
        if (count==0) {
            insertSQL = [NSString stringWithFormat:
                         @"INSERT INTO personaldetailsTable (userID, name, surname, gender, dob, height, weight, doctorname, doctormail) VALUES ('1','%@','%@','%@','%@','%@','%@','%@','%@')",
                         name,surname,gender,dob,height,weight,doctorname,doctormail];

            
        }
        else // UPDATE TIS PRWTHS EGGRAFHS
        {
            insertSQL = [NSString stringWithFormat:@"UPDATE personaldetailsTable SET userID ='1',name='%@',surname='%@',gender='%@',dob='%@',height='%@',weight='%@',doctorname='%@',doctormail='%@' WHERE userID='1'", name,surname,gender,dob,height,weight,doctorname,doctormail];
        }
        
        
        const char *sql = [insertSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"Problem with prepare statement");
            return;
        }else{
            
            if(sqlite3_step(sqlStatement)==SQLITE_DONE){
                sqlite3_finalize(sqlStatement);
                sqlite3_close(db);
            }
            
        }
    }
    
}

-(void) selectPersonalDetails{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        
        
        const char *sql = "select * from personaldetailsTable";

        
        sqlite3_stmt *sqlStatement;
        
        
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"There is a problem with prepare statement");
            return;
        }else{
            while (sqlite3_step(sqlStatement)==SQLITE_ROW) {
                
                char * checkChar = (char*)sqlite3_column_text(sqlStatement, 1);
                if (checkChar!=NULL) {
                    Asthma * newToDo = [[Asthma alloc] init];
                    // newToDo.duration = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)];
                    // newToDo.prepost= [NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)];
                   // NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 0)]);
                   // NSLog([NSString stringWithUTF8String:(char *)sqlite3_column_text(sqlStatement, 1)]);
                    
                }
                
            }
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
}

- (int) GetDailyCountPersonalDetails
{
    int count = 0;
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT COUNT (*) FROM personaldetailsTable WHERE userID='1'"];
        
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                count = sqlite3_column_int(sqlStatement, 0);
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    
    
    return count;
}

//////// FUNCTIONS MEDICATIONN ///////////////

-(void)updateMedication:(NSString *)inputmedication :(NSNumber *)dose :(NSString *)inputmedication2 :(NSNumber *)dose2 :(NSString *)inputmedication3 :(NSNumber *)dose3 
{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        
        int count = [self GetDailyCountMedication];
        NSLog(@"%d",count);
        NSString *insertSQL;
        
        // ELEGXOS GIA AN YPARXEI PRWTH EGGRAFH
        if (count==0) {
            insertSQL = [NSString stringWithFormat:
                         @"INSERT INTO medicationTable (medicationID,inputmedication, dose, inputmedication2, dose2, inputmedication3, dose3) VALUES ('1','%@','%@','%@','%@','%@','%@')",
                         inputmedication, dose, inputmedication2, dose2, inputmedication3, dose3];
            
        }
        else // UPDATE TIS PRWTHS EGGRAFHS
        {
            insertSQL = [NSString stringWithFormat:@"UPDATE medicationTable SET medicationID='1',inputmedication ='%@',dose='%@', inputmedication2='%@',dose2='%@', inputmedication3='%@', dose3='%@' WHERE medicationID='1'", inputmedication, dose, inputmedication2, dose2, inputmedication3, dose3];
        }
        
        const char *sql = [insertSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"Problem with prepare statement");
            return;
        }else{
            
            if(sqlite3_step(sqlStatement)==SQLITE_DONE){
                sqlite3_finalize(sqlStatement);
                sqlite3_close(db);
            }
            
        }
    }
    
}

-(void) selectMedication{
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
        return;
    }else{
        
        
        const char *sql = "select * from medicationTable";
        
        sqlite3_stmt *sqlStatement;
        
        
        if(sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) != SQLITE_OK)
        {
            NSLog(@"There is a problem with prepare statement");
            return;
        }else{
            while (sqlite3_step(sqlStatement)==SQLITE_ROW) {
                
                char * checkChar = (char*)sqlite3_column_text(sqlStatement, 1);
                if (checkChar!=NULL) {
                    Asthma * newToDo = [[Asthma alloc] init];
                    
                }
                
            }
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
}

- (int) GetDailyCountMedication
{
    int count = 0;
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT COUNT (*) FROM medicationTable WHERE medicationID='1'"];
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                count = sqlite3_column_int(sqlStatement, 0);
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    
    
    return count;
} 
- (NSString *) selectFromTableNSString:(NSString *) field:(NSString *) table
{
    NSString *_field ;
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT %@ FROM %@ ",field,table];
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                _field =[NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 0)];
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    
    
    return _field;
}
- (NSNumber *) selectFromTableNSNumber:(NSString *)field :(NSString *)table
{
    NSNumber *_field ;
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT %@ FROM %@ ",field,table];
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
               // _field =[NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 0)];
               _field = [NSNumber numberWithFloat:(float)sqlite3_column_double(sqlStatement, 0)];
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    
    
    return _field;
}
///// SELECT PEAK FLOW VALUES FROM DATABASE
-(NSMutableDictionary *) selectFromPeakFlow
{
    NSString *_field1;
    NSString *_field2;
    NSMutableDictionary *dictionary = [[NSMutableDictionary alloc] init];
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT * FROM peakflowTable"];
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                _field1 =[NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 0)];
                _field2 =[NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 1)];
                [dictionary setValue:_field2 forKeyPath:_field1];
            }

        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }    
    return dictionary;
}

// SELECT MAX VALUE OF PEAK FLOW
- (NSNumber *) selectMaxPeakFlow{
    
    NSNumber *_field ;
   
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    NSNumber *maxPeakFlow =[NSNumber numberWithInt:0];
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        NSDate *dateCompare = [NSDate date];
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy-MM"];
        NSString *CurrentDate = [dateFormatter stringFromDate:dateCompare];
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT peakflow FROM peakflowTable WHERE datePeakFlow LIKE '%@%%'",CurrentDate];
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                _field =[NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 0)];
               
                if ([maxPeakFlow intValue] < [_field intValue] ) {
                    maxPeakFlow =_field;

                }


            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }

    return maxPeakFlow;
}
// SELECT MIN VALUE OF PEAK FLOW
-(NSNumber *)selectMinPeakFlow{
    
    NSNumber *_field;
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    NSNumber *minPeakFlow=[NSNumber numberWithInt:1000];
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        NSDate *dateCompare = [NSDate date];
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy-MM"];
        NSString *CurrentDate = [dateFormatter stringFromDate:dateCompare];
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT peakflow FROM peakflowTable WHERE datePeakFlow LIKE '%@%%'",CurrentDate];
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                _field =[NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 0)];
                
                if ([minPeakFlow intValue] > [_field intValue] ) {
                    minPeakFlow=_field;
                    
                }
                
                
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }

    return minPeakFlow;
}
/// GET MONTHLY ATTACKS
-(NSMutableArray *) GetMonthlyttacks{
    NSMutableArray *attacks = [[NSMutableArray alloc] init];
    NSMutableArray *monthlyAttacks = [[NSMutableArray alloc] init];
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        NSDate *dateCompare = [NSDate date];
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy-MM"];
        
        
        NSString *CurrentDate = [dateFormatter stringFromDate:dateCompare];
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT * FROM attackTable WHERE dateAttack LIKE '%@%%' ",CurrentDate];
        
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                
                NSString * Dateofattack = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 0)];
                NSNumber * Duration = [NSNumber numberWithFloat:(float)sqlite3_column_double(sqlStatement, 1)];
                NSString * Prepostmeds = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 2)];
                NSString * Notes = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 3)];
                NSString * Location = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 4)];
                
                attacks = [NSMutableArray arrayWithObjects: Dateofattack,Duration, Prepostmeds, Notes, Location, nil];
                [monthlyAttacks addObject:attacks];
                
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    return monthlyAttacks;

}
/// Get Triggers for specific date
- (NSMutableArray *) GetTriggersPerDate:(NSString *)dateOfAttack
{

    NSMutableArray *triggersMutableArray = [[NSMutableArray alloc] init];
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT * FROM triggersTable WHERE dateTriggers LIKE '%@%%' ",dateOfAttack]; // %@ string %%-->% auto poy synexizei meta tin parametr
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            NSString * Dust = [[NSString alloc]initWithString:@""];
            NSString * Pollen = [[NSString alloc]initWithString:@""];
            NSString * Exercise = [[NSString alloc]initWithString:@""];
            NSString * Smoke = [[NSString alloc]initWithString:@""];
            NSString * Illness = [[NSString alloc]initWithString:@""];
            NSString * Food = [[NSString alloc]initWithString:@""];
            NSString * Allergy = [[NSString alloc]initWithString:@""];
            NSString * highTemp =[[NSString alloc]initWithString:@""];
            NSString * lowTemp = [[NSString alloc]initWithString:@""];
            
            int flag=0;
            //Loop through all the returned rows (should be just one)
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                flag=1;
                //_field =[NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 0)];
                Dust = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 1)];
                Pollen = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 2)];
                Exercise = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 3)];
                Smoke = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 4)];
                Illness = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 5)];
                Food = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 6)];
                Allergy = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 7)];
                highTemp = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 8)];
                lowTemp = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 9)];
                
                triggersMutableArray = [NSMutableArray arrayWithObjects: Dust,Pollen, Exercise, Smoke, Illness, Food, Allergy, highTemp, lowTemp, nil];
            }
             if (flag == 0) {
               triggersMutableArray = [NSMutableArray arrayWithObjects: Dust,Pollen, Exercise, Smoke, Illness, Food, Allergy, highTemp, lowTemp, nil];
            }
            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    
    
    return triggersMutableArray;
}

/// Get Symptoms for specific date
- (NSMutableArray *) GetSymptomsPerDate:(NSString *)dateOfAttack   
{
    
    NSMutableArray *symptomsMutableArray = [[NSMutableArray alloc] init];
    
    //Get list of directories in Document path
    NSArray * dirPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    //Define new path for database
    NSString * documentPath = [[dirPath objectAtIndex:0] stringByAppendingPathComponent:@"asthma.db"];
    
    
    if(!(sqlite3_open([documentPath UTF8String], &db) == SQLITE_OK))
    {
        NSLog(@"An error has occured.");
    }
    else
    {
        // DATE
        NSDate *now = [NSDate date];
        NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
        [components setHour:10];
        NSDate *today10am = [calendar dateFromComponents:components];
        
        NSString *selectSQL =[NSString stringWithFormat:
                              @"SELECT * FROM symptomsTable WHERE date LIKE '%@%%' ",dateOfAttack]; // %@ string %%-->% auto poy synexizei meta tin parametr
        const char *sql = [selectSQL UTF8String];
        
        sqlite3_stmt *sqlStatement;
        if( sqlite3_prepare_v2(db, sql, -1, &sqlStatement, NULL) == SQLITE_OK )
        {
            
            NSString * wheezing = [[NSString alloc]initWithString:@""];
            NSString * dcough = [[NSString alloc]initWithString:@""];
            NSString * sbreath = [[NSString alloc]initWithString:@""];
            NSString * wchest = [[NSString alloc]initWithString:@""];
            NSString * sleep = [[NSString alloc]initWithString:@""];
            //Loop through all the returned rows (should be just one)

            int flag =0;
            while( sqlite3_step(sqlStatement) == SQLITE_ROW )
            {
                flag =1;
                //_field =[NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 0)];
                wheezing = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 1)];
                dcough = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 2)];
                sbreath = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 3)];
                wchest = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 4)];
                sleep = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sqlStatement, 5)];

                
                symptomsMutableArray = [NSMutableArray arrayWithObjects: wheezing, dcough, sbreath, wchest, sleep, nil];
            }
            if (flag == 0) {
                symptomsMutableArray = [NSMutableArray arrayWithObjects: wheezing, dcough, sbreath, wchest, sleep, nil];
            }

            
        }
        else {
            NSLog( @"Failed from sqlite3_prepare_v2. Error is:  %s", sqlite3_errmsg(db) );
            
        }
        
        if(sqlite3_step(sqlStatement)==SQLITE_DONE){
            sqlite3_finalize(sqlStatement);
            sqlite3_close(db);
        }
        
    }
    
    
    
    return symptomsMutableArray;
}
@end

